Intro
=====

This document contains a list of the latest stable releases of the most
important packages for Linux as well as instructions for newcomers to
the 2.0.x series of kernels.  By glancing through it, you should be
able to find out what you need to upgrade in order to successfully run
the latest kernels.  Note that I tend to mention the earliest releases
of software known to work, not necessarily the latest and greatest
versions, as the goal is to provide you with a list of sure-to-work
software.

   It was originally based on material from the linux-kernel mailing
list, Jared Mauch's web page "Software Victims of the 1.3 Kernel
Development" (http://www2.nether.net/~jared/victim.html), and Axel
Boldt's (boldt@math.ucsb.edu) Configure.help file, among other sources,
and was originally written and maintained by Alessandro Sigala
(ssigala@globalnet.it).

   Para aquellos que prefieran una version en castellano de este
documento, consultad la traduccion de Alfredo Sanjuan en
http://slug.ctv.es/~alfredo/Cambios.html (Spanish translation).

   Akik magyarul szeretnenek olvasni az uj kernellel kapcsolatos
valtozasokrol, az alabbi cimen megtalaljak Nyitrai Tamas forditasat:
http://www.datanet.hu/generations/linux/newkernel.html (Hungarian
translation).

   Tamas also maintains a version of this file at
http://www.datanet.hu/generations/linux/Changes.html (English version).

   For people who prefer Japanese (thanks to Mitsuhiro Kojima): Kono
bunshou no nihongo ban wa
http://jf.gee.kyoto-u.ac.jp/JF/v2.0/Changes-2.0.html ni arimasu.

   Voyez le site http://www.linux-kheops.com/traduc/kernels/ pour la
traduction francaise (merci, David Bourgin).  (French translation)

   Per quelli che preferiscono avere una versione in Italiano di questo
documento, si consulti la traduzione di Giovanni Bortolozzo reperibile a
http://www.pluto.linux.it/ildp/kernel/Changes-2.0.html (Italian
translation).

   The most current version should always be available from
http://cyberbuzz.gatech.edu/kaboom/linux/ as well.

Last updated: December 16, 1999.
Current Author: Chris Ricker (kaboom@gatech.edu).

Current Releases (the latest necessary for basic functionality, not
*******************************************************************

   necessarily the latest and greatest)

- Kernel modules	 2.0.0
- PPP daemon		 2.2.0f
- Dynamic linker (ld.so) 1.7.14
- GNU CC		 2.7.2.1
- Binutils		 2.8.1.0.23
- Linux C Library	 Stable:  5.2.18, Beta:  5.4.33
- Linux C++ Library	 2.7.2.1
- Termcap		 2.0.8
- Procps		 1.01
- Gpm			 1.10
- SysVinit		 2.64
- Util-linux		 2.5
- Mount                  2.5p
- Net-tools              1.32-alpha
- Kbd                    0.91

Note that it is _very_ unlikely that you will be able to compile the
2.0 kernel with gcc-3.x or binutils 2.9.x, and even if it compiles, it
might not work properly.

Upgrade notes
*************

Network errors with recent kernels
==================================

   Many default network scripts are set up to add a route to the
localhost at 127.0.0.1 at startup.  However, they do this incorrectly.
To fix the error, which is now spotted by the kernel (causing many
daemons to quit working), look for a line like `route add -net
127.0.0.1' in your network configuration files and change it to `route
add -net 127.0.0.0'.

   This error is present in all Red Hat distributions through Red Hat
3.03 (and derivative distributions like Caldera).  If you're running
one of these, edit /etc/sysconfig/network-scripts/ifup-lo, changing the
line `route add -net $(IPADDR)' to `route add -net 127.0.0.0' and you
should be fine.

   People have also reported problems due to the naming of the dummy
network interface driver.  If the dummy driver is compiled into the
kernel, its name is "dummy."  If the dummy driver is compiled as a
module, its name is "dummy0."  Furthermore, more than one dummy driver
can be loaded if compiled as a module.  Each subsequent loading of the
driver adds a new dummy interface whose name is incremented by one
("dummy1," "dummy2," etc.).

Booting Changes
===============

   The boot support in 2.0.x (for arch/i386) has been enhanced so that
it now can load bigger kernels (bzImage) and that the loaders now can
load an initial ramdisk (initrd). For initrd see
Documentation/initrd.txt. For building bigger kernels use one of the
following make targets: bzImage, bzlilo, bzdisk (equivalent to make
targets zImage, zlilo, and zdisk respectively). If you want or need to
use the new features you'll need to upgrade your bootloaders.  Lilo can
be found at ftp://lrcftp.epfl.ch/pub/linux/local/lilo/lilo.19.tar.gz.
LOADLIN is at
ftp://sunsite.unc.edu/pub/linux/system/boot/dualboot/lodlin16.tgz.  If
you're using more unusual loaders like SysLinux or etherboot, the
latest versions are 1.3 and 2.0, respectively.

   Ramdisk support does not work with the latest kernels if ramdisk=0
option is present.  Many older distributions (mainly Slackware) have
this option in their lilo.config file.  Comment it out and re-run lilo
if you need ramdisks.

   The definition of SIOCSARP in /usr/include/linux/sockios.h was
changed.  This means bootpd has to be re-compiled in order to work.

   The kernel reboot method is now, by default, a cold reboot so that
the kernel will work on systems that don't support other methods.  If
you want to be able to do a warm reboot, add a reboot=warm option to
lilo.conf.

The Linux C Library
===================

   The latest stable Linux C Library release is 5.2.18.  If you upgrade
to this from 5.0.9 or earlier, be sure to read the
`release.libc-5.2.18' file, since GNU make and a few other fairly
important utils can be broken by the upgrade.

   A current common Linux C Library release is 5.3.12. In this release
there are some important changes that may cause troubles to buggy
programs (programs that call free() on a pointer not returned by
malloc(), such as Netscape, work with previous libc, but not with this
release) so read the `release.libc-5.3.12' file carefully!  In the
latest libc releases a dirent bug, which erroneously defined d->reclen
to d->namlen if USE_GNU was defined, has been fixed.  Unfortunately,
some GNU packages depend on this bug.  GNU make 3.xx is one of them.
To fix that you need to patch and recompile those programs (a patch for
make is included in the file `release.libc-.5.3.9', and the address to
obtain a precompiled binary is at the end of this file).

   Also, the libc-5.3.x line has a known security hole relating to
rlogin.  Libc-5.3.12 fixes this, so if you're going to run an
experimental libc, be sure to upgrade to 5.3.12.  Libc-5.4.33 is
currently available as well, but it may have problems, so caveat
emptor.  It fixes lots of problems, but may break even more programs
than 5.3.12.

   If you're getting an error message that is something to the effect of

   `fcntl_setlk() called by process 123 with broken flock() emulation'

   then you need to upgrade to at least libc-5.2.18 as well.  A proper
(in other words, BSD-style ;-) flock system call was added to 2.0.x,
and older libc's will now give this error.  It doesn't *really* matter,
so you can just ignore it. If it really annoys you, upgrade libc (and
recompile any static binaries you might have that are linked against
the old libc).  If you're feeling lazy, just comment out

   `                printk(KERN_WARNING
"fcntl_setlk() called by process %d with broken flock()
  emulation\n",                        current->pid);'

   in linux/fs/locks.c and recompile.  If you're still running a.out,
there's an unofficial libc-4.7.6 release out to which you can upgrade
to fix this problem.  Libc is available from
ftp://ftp.win.tue.nl/pub/linux-local/libc.archive/libc/.

GCC Signal 11 error
===================

   Many people have been reporting messages like the following,
especially when compiling a new kernel:

   `gcc:  Internal compiler error:  program cc1 got fatal signal 11'.

   This is NOT a kernel bug.  Rather, these messages are generally
caused by hardware problems.  See http://www.bitwizard.nl/sig11/ for
the sig11 FAQ.

   On the other hand, if you're using a gcc patched for Pentium
optimization and are getting these errors, downgrade to a standard GNU
gcc before assuming your hardware (or the kernel) is to blame.

   On a related note, if you get random OOPses that don't seem to be
related to anything and you have a motherboard with APM support, try
disabling the APM support and/or compiling the kernel with APM support.

Procps utilities
================

   Due to changes in the structure of the /proc filesystem, you need to
upgrade procps to the latest release, currently 1.01.  Otherwise,
you'll get floating point errors with some ps commands or other similar
surprises.  Grab
ftp://sunsite.unc.edu/pub/historic-linux/ftp-archives/sunsite.unc.edu/Sep-29-1996/system/Status/ps/procps-1.01.tar.gz.

Kernel Modules
==============

   Almost all drivers in 2.0.x can be modules, and kerneld is now
incorporated into the kernel.  To take advantage of this, you'll need
the latest version of the module support apps. These are available at
ftp://sunsite.unc.edu/pub/linux/kernel.org/pub/linux/kernel/v2.0/modules-2.0.0.tar.gz.

Note: If you try to load a module and get a message like

   `gcc2_compiled, undefined Failed to load module!  The symbols from
kernel 1.3.foo don't match 1.3.foo'

   where `foo' is a number for a recent kernel, then it's definitely
time to upgrade module utilities.

   Another little tip: you can't have both a.out *and* ELF support
compiled as modules.  Otherwise, you get a nice Catch-22 when you try
to run insmod to install a.out/ELF support so you can run insmod ;-).
If you have an all-ELF system, but need a.out for the occasional legacy
app, then you can do a.out support as a module.  Otherwise, you should
probably leave it in the kernel, and if you haven't gone ELF yet, you
can probably say no to ELF support.  Similarly, any partitions that you
have to mount at startup have to have their necessary file system and
device drivers compiled into the kernel, so don't get grandiose ideas
about going completely modular and then forget to compile ext2fs
support and ide/SCSI drive support into your kernel ;-).

Kernel messages
===============

   Kernel messages without a specific log level use the kernel's
default log level.  In 1.2 kernels, the default log level was 6
(information), while in 2.0.x kernels it is 4 (warning).  Adjust your
configuration of syslogd appropriately (or edit printk.c in the kernel
source ;-).

PPP driver
==========

   You need to be running a pppd from ppp-2.2.0.tar.gz or greater.  The
latest stable release is 2.2.0f and is available at
ftp://sunsite.unc.edu/pub/historic-linux/distributions/slackware/3.1/source/n/ppp/ppp-2.2.0f.tar.gz

Named pipes (SysVinit)
======================

   Linux's handling of named pipes changed (it now does it The Right Way
instead of the SunOS way ;-).  This broke some programs that depended
on the SunOS behavior, most notably SysVinit.  If you're running 2.59
or earlier, you will probably get a weird error on shutdown in which
your computer shuts down fine but "INIT: error reading initrequest" or
words to that effect scroll across your screen hundreds of times.  To
fix, upgrade to
ftp://sunsite.unc.edu/pub/historic-linux/ftp-archives/sunsite.unc.edu/Sep-29-1996/system/Daemons/init/sysvinit-2.64.tar.gz.

   If you're trying to run NCSA httpd, you might have problems with
pre-spawning daemons.  Upgrade to the latest release (1.5.2), available
from http://hoohoo.ncsa.uiuc.edu/ or check out Apache
(http://www.apache.org/).

   The new named pipe behavior also causes problems with Hylafax.  If
you're running the hylafax daemon, it will just keep eating up CPU time
until you have no idle time free.  To fix this, edit port.h included
with the Hylafax distribution and change the line

   CONFIG_OPENFIFO="O_RDONLY"

   to

   CONFIG_OPENFIFO="O_RDWR"

   A similar method (finding all named pipes opened read-only and
changing them to read-write) will fix any program that is broken
because of this change.

File Locking (Sendmail)
=======================

   As of pre2.0.6 (aka 1.99.6), mixed-style file locking is no longer
allowed.  For example, a file cannot be simultaneously locked with
`flock' and `fcntl'.  See Documentation/locks.txt for all the gory
details.  Among the programs this has impacted are older sendmails.  If
you get a message that sendmail cannot lock aliases.dir (or other
files), you'll need to upgrade to at least 8.7.x. The latest sendmail
is at ftp://ftp.cs.berkeley.edu/ucb/src/sendmail/.

Uugetty
=======

   Older uugettys will not allow use of a bidirectional serial line.  To
fix this problem, upgrade to
ftp://tucows.belgium.eu.net/pub/linux/slackware/slackware-3.3/source/a/getty/getty_ps-2.0.7i.tar.gz.

Kbd
===

   For those of you needing non-ASCII character/font support, you should
upgrade to ftp.funet.fi:/pub/OS/Linux/PEOPLE/Linus/old-kbd/kbd-0.91.tar.gz.

Mount
=====

   The mount util is distributed as part of util-linux, which is
currently at release 2.5.  Some may find, especially when using the
loop or xiafs file system, NFS, or automounting, that they need to
upgrade to the latest release of mount, available from
ftp://ftp.win.tue.nl/pub/linux/utils/attic/mount/mount-2.5p.tar.gz.

Console
=======

   The Linux console type has changed.  If your setup is old enough
that you have problems, you'll need to update your termcap.  To fix,
add linux to one of the types in /etc/termcap or snoop around
http://www.ccil.org/~esr/ncurses.html (reputedly the latest universal
termcap maintainer).  You may also need to update terminfo by running
the following as root:

   ln -s /usr/lib/terminfo/l/linux /usr/lib/terminfo/c/console

   Better yet, just get the latest official Linux termcap from
ftp://sunsite.unc.edu/pub/historic-linux/distributions/slackware/3.1/source/d/libc/termcap-2.0.8.tar.gz.
If you upgrade to this release read the `README' file contained into
the package to get some important information about the `tgetent'
function changes!
Note that there is now a fixed version at
ftp://sunsite.unc.edu/pub/historic-linux/ftp-archives/sunsite.unc.edu/Sep-19-1996/GCC/termcap-2.0.8.fix.
If some of your apps complain that termcap entries are too long and
you don't need some of the more esoteric terms in the standard 2.0.8
termcap, just download termcap-2.0.8.fix and move it to /etc/termcap.

   Also, the console driver is now responsible for keeping track of
correspondence between character codes and glyph bitmaps.  If you
encounter problems, try `loadunimap def' to get back the default
correspondence.

Hdparm
======

   Hdparm has been upgraded to take advantage of the latest features of
the kernel drivers.  The latest non-beta version can be found at
ftp://sunsite.unc.edu/pub/linux-historic/ftp-archives/sunsite.unc.edu/Sep-19-1996/kernel/patches/diskdrives/hdparm-3.1.tar.gz.

IP Accounting
=============

   All IP packets coming in or going out via one of the network
interfaces are now passing the accounting chain.  So, packets being
forwarded are passing this chain twice.  Since pre2.0.7 (aka 1.99.7),
accounting rules can be defined so that they will only match in one
direction (either incoming or outgoing).

   There also exists a possibility to match on device names and/or
device addresses, so that only packets coming in/going out via that
device (network interface) match with a rule.  You'll need to get
ipfwadm from
ftp://ftp.sunsite.auc.dk/disk2/slackware/slackware-8.0/pasture/pasture-sources/ipfwadm-2.3.0/ipfwadm-2.3.0.tar.gz to
use this.

IP Firewalls
============

   The IP firewall code has been changed drastically for 2.0.x. There
are now 3 categories of firewall rules: one for incoming packets, one
for outgoing packets, and one for packets being forwarded.  There also
exists a possibility to match on device names and/or device addresses,
so that only packets coming in/going out via that device (network
interface) match with a rule.  This is especially useful to prevent
spoofing.  You'll need to get
ftp://ftp.sunsite.auc.dk/disk2/slackware/slackware-8.0/pasture/pasture-sources/ipfwadm-2.3.0/ipfwadm-2.3.0.tar.gz to
to use this.

IP Masquerading
===============

   IP masquerading is now part of the standard kernel.  However, you
always need to load separate modules (ip_masq_ftp.o and/or
ip_masq_irc.o) if you are going to use FTP or IRC in combination with
masquerading.  You'll need to get
ftp://ftp.sunsite.auc.dk/disk2/slackware/slackware-8.0/pasture/pasture-sources/ipfwadm-2.3.0/ipfwadm-2.3.0.tar.gz to
to use this.

   To enable IP forwarding, you may need to

   echo 1 > /proc/sys/net/ipv4/ip_forwarding

   as well.

ISDN support
============

   The new kernels support ISDN.  You'll need ISDN utils available from
ftp://ftp.uni-jena.de/pub/fsu/rz/software/linux/internetworking/isdn/isdn4k-utils-2.0.tar.gz
to try this.

Frame Relay
===========

   Frame relay support for Linux is now available as well.  Currently,
only Sangoma cards are supported, but the interface is such that others
will be as drivers become available. To use this, grab
ftp://ftp.task.gda.pl/mirror/ftp.invlogic.com/pub/fr/frad-0.15.tgz
(soon to be frad-0.20.tgz). Another package of interest is
ftp://ftp.task.gda.pl/mirror/ftp.invlogic.com/pub/routing/routing-2.0.33.tgz
(which allows Linux to make routing decisions based on packet source).

Networking
==========

   Some of the /proc/net entries have changed.  You'll need to upgrade
to the latest net-tools in
ftp://ftp.task.gda.pl/mirror/ftp.invlogic.com/pub/linux/routing/,
where the latest is currently net-tools-1.33.tar.gz.
See http://www.inka.de/sites/lina/linux/NetTools/index_en.html for more
information.  Note that there is currently no ipfw (which is part of
net-tools) which works with 2.0.x kernels.  If you need its functions,
learn how to use ipfwadm or patch ipfw to get it to work (ipfw's current
maintainer does not currently have time to fix it).

Xntpd
=====

   Older versions of xntpd will not work with the latest kernels.
Upgrade to xntp3.5f.tar.Z, available from
ftp://louie.udel.edu/pub/ntp/xntp3.5f.tar.Z.

Sound driver
============

   The sound driver was upgraded in the 2.0.x kernels, breaking vplay.
To fix this problem, get a new version of the sndkit from
ftp://sunsite.unc.edu/pub/historic-linux/distributions/slackware/3.1/source/extra-stuff/sound-utilities/snd-util-3.5.tar.gz.
Some users report that various other sound utils (cdd2wav-sbpcd, for
example) need to be recompiled before they will work with the new
kernels.

Tcsh
====

   If tcsh acts funny, get the source from
ftp://anise.ee.cornell.edu/pub/tcsh and add #define SYSMALLOC in
config_f.h before recompiling tcsh.  Binaries can be found in
ftp://sunsite.unc.edu/pub/Linux/system/Shells/ and a corrected one will
probably wind up there eventually.

Make
====

   If make no longer works, you need to read the release notes for the
libc you upgraded to.  The latest libc and release notes can be found at
ftp://tsx-11.mit.edu/pub/linux/packages/GCC.  This is NOT an error due
to the kernel, though many people have mistakenly thought it is.  When
you upgrade to libc-5.3.9, you have to patch make to get it to work.
All of this is documented in the release notes with libc.  Upgrading
libc can also break xterm support.  If it does, you need to recompile
xterm.

Loop device
===========

   2.0.x kernels include loop device support which lets you mount a
file as a file system, which can allow for all sorts of cool things
like encrypted file systems and such.  To use it, you'll need a
modified version of mount from
ftp://ftp.win.tue.nl/pub/linux-local/utils/attic/mount/mount-2.5k.tar.gz;
preliminary work on encrypted file system support can be found in
ftp.funet.fi:/pub/Linux/BETA/loop/des.1.tar.gz.

Multiple device
===============

   Multiple device support (allowing you to group several partitions
into one logical device) has also been added.  Check out
ftp://sweet-smoke.ufr-info-p7.ibp.fr/pub/Linux/md035.tar.gz to try this
out.

Arp
===

   Arp daemon support has been added.  Check out
http://www.loran.com/~layes/arpd/index.html for more info and
http://www.loran.com/~layes/arpd/arpd-1.0.2.tar.gz for a copy of arpd.

Quota
=====

   Quota support has also been added.  You need to get quotas-1.55 from
ftp://ftp.funet.fi/pub/Linux/kernel/src/subsystems/quota/all.tar.gz. You
may need to copy its mntent.h over to /usr/include/mntent.h to get it to
compile.

Process Accounting
==================

   Process accounting support has also been integrated into the new
kernels. To use this feature, you'll need to get
ftp://iguana.hut.fi/pub/linux/Kernel/process_accounting/acct_1.3.73.tar.gz.

Bdflush and Updated
===================

   Bdflush has also been integrated into the new kernels, so those of
you using it on older systems no longer need to hunt for the patches to
implement it once you upgrade to 2.0.x.  You do still need to run the
update daemon, however.  You should probably upgrade to the latest
updated, currently
ftp://sunsite.unc.edu/pub/Linux/system/Daemons/updated-1.2.tar.gz.  This
(and later) versions will not spawn a bdflush daemon, since that is now
done by the kernel (kflushd).  If you upgrade, be sure to leave update
in your init scripts and remove bdflush.

APM support
===========

   Advanced Power Management (APM) support has been added to the kernel
as well.  APM, which is primarily of use in laptops, provides access to
battery status information and may help to conserve battery power.  The
support files can be found in
http://www.worldvisions.ca/~apenwarr/apmd/

iBCS and Dosemu
===============

   For a version of iBCS that works with 2.0.x kernels, grab
ftp://tsx-11.mit.edu/pub/linux/BETA/ibcs2/ibcs-2.0-960610.tar.gz

   For a version of Dosemu that works (well, at least as well as DOS
ever works ;-), get
ftp://tsx-11.mit.edu/pub/linux/ALPHA/dosemu/Development/dosemu-0.64.0.3.tgz
or check out http://www.ednet.ns.ca/auto/rddc. Be sure to follow the
instructions in README.newkernels about patching your include files, or
it will not compile.

Mtools and Fdutils
==================

   The floppy ioctl numbering scheme has changed for 2.0.x.  For
backwards compatibility, the old system was supported through 1.3.x and
will generate a warning in 2.0.  In 2.1.x, the old scheme will
disappear entirely.

   To avoid trouble (or at least annoying messages), you'll need to
recompile any programs which emit floppy ioctls, including mtools and
fdutils.  For mtools, get
ftp://sunsite.unc.edu/pub/Linux/utils/disk-management/mtools-3.0.src.tar.gz
and for fdutils, get
ftp://sunsite.unc.edu/pub/Linux/system/Misc/fdutils-4.3.src.tar.gz.

   In the future, fdformat might disappear entirely, so get used to
using superformat instead.

Cyclades Serial Driver
======================

   The Cyclades driver has been changed so that the minor numbers start
at 0 instead of 32 (for example, ttyC0 should be major 19, minor 0 for
2.0.x kernels; in older kernels, it would have been major 19, minor
32).  Use mknod or a sufficiently new version of MAKEDEV to fix this.

NCR 53c810 SCSI Driver
======================

   Drivers for this card are now included in the standard linux source.
However, they require Perl to be installed before they will compile.
As far as I know, this is the only code in the kernel source that
requires Perl to compile.  If your kernel compile fails and you happen
to have included this driver in your configuration, make sure you have
Perl installed.

Perl
====

   While we're on the subject, changes made for the 2.0.x series cause
the connect() Perl (both 4 and 5) call to time out while connecting to
remote systems.  The problem is not actually in the connect() call;
rather, the optional bind() call usually used with connect() causes the
problem.  Remove the bind() call and your Perl scripts should connect.

   Also, Perl scripts using the readdir call now misbehave if you're
using an old version of Perl, due to changes in libc.  Upgrade to a
more current Perl to avoid any unpleasantness.

Groff
=====

   Those of you running Slackware may experience weirdness with man
pages due to changes in groff.  If your man pages display <AD> for -
when present at the end of a line, try setting an appropriate value
(many have reported success with "latin1", for example) for the
environmental variable LESSCHARSET.  Another, and probably better,
solution is to edit the file /usr/lib/man.config and change all
`-Tlatin1' options to `-Tascii'.  An alternate solution, for those of
you who can't reformat your man files in .../cat* directories is to
edit /usr/lib/man.config, setting the PAGER to `PAGER
(LESSCHARSET=latin1;export LESSCHARSET;/usr/bin/less -is)'.

E2fsprogs
=========

   e2fsprogs 1.02 will work with the latest kernels, but it cannot be
compiled on them.  If you need (or want) to compile your own copy,
you'll need to get the latest version, currently available at
ftp://tsx-11.mit.edu/pub/linux/packages/ext2fs/e2fsprogs-1.06.tar.gz.

FlagShip and /dev/full
======================

   The behavior of /dev/full changed with kernel 2.0.31.  In addition to
improving system security, the change broke executables created by the
FlagShip database compiler.  Fixes can be found at http://www.fship.com
via the "What's New" or "Support" buttons.

How to know the version of the installed programs
*************************************************

   There are some simple methods useful to know the version of the
installed programs and libraries.  The SysVinit version display
requires that you be logged in as root.

GNU CC: gcc -v and gcc --version
PPP: pppd -h (wrong but it show the version)
Libc: ls -l /lib/libc.so.5
Libc++: ls -l /usr/lib/libg++.so
Binutils: ld -v
ldd: ldd -v and ldd -V
termcap: ls -l /lib/libtermcap.so.*
modules: insmod -V
procps: ps --version
SysVinit: cat /proc/`cat /var/run/syslog.pid`/environ|strings|awk '$1 ~
/INIT_VERSION/ {print}'

Where to get the files
**********************

Binutils
========

ftp://tsx-11.mit.edu:/pub/linux/packages/GCC/binutils-2.7.0.3.bin.tar.gz
Installation notes:
ftp://tsx-11.mit.edu:/pub/linux/packages/GCC/release.binutils-2.7.0.3

GNU CC
======

ftp://sunsite.unc.edu/pub/Linux/GCC/gcc-2.7.2.1.bin.tar.gz
Installation notes:
ftp://sunsite.unc.edu/pub/Linux/GCC/release.gcc-2.7.2.1

Linux C Library
===============

The stable 5.2.18 release:
ftp://sunsite.unc.edu/pub/Linux/GCC/libc-5.2.18.bin.tar.gz
Installation notes for 5.2.18:
ftp://sunsite.unc.edu/pub/Linux/GCC/release.libc-5.2.18

The latest 5.4.33 release:
ftp://sunsite.unc.edu/pub/Linux/GCC/libc-5.4.33.bin.tar.gz
Installation notes for 5.4.33:
ftp://sunsite.unc.edu/pub/Linux/GCC/release.libc-5.4.33

Patched make sources:
ftp://sunsite.unc.edu/pub/Linux/devel/make/make-3.74.patched.tar.gz
Patched make binary:
ftp://sunsite.unc.edu/pub/Linux/devel/make/make-3.74-direntfix-elf.tgz

Linux C++ Library
=================

ftp://sunsite.unc.edu/pub/Linux/GCC/libg++-2.7.2.1.bin.tar.gz
Installation notes:
ftp://sunsite.unc.edu/pub/Linux/GCC/release.libg++-2.7.2.1

Dynamic Linker
==============

ftp://sunsite.unc.edu/pub/Linux/GCC/ld.so-1.7.14.tar.gz

Termcap Library
===============

ftp://sunsite.unc.edu/pub/Linux/GCC/termcap-2.0.8.tar.gz

Modules utilities
=================

The latest public release:
ftp://sunsite.unc.edu/pub/Linux/kernel/modules-2.0.0.tar.gz

PPP Daemon and utilities
========================

The latest public release:
ftp://sunsite.unc.edu/pub/Linux/system/Network/serial/ppp/ppp-2.2.0f.tar.gz

Procps utilities
================

ftp://sunsite.unc.edu/pub/Linux/system/Status/ps/procps-1.01.tgz

Gpm mouse utilities
===================

ftp://iride.unipv.it/pub/gpm/gpm-1.10.tar.gz
ftp://sunsite.unc.edu/pub/Linux/system/Daemons/gpm-1.10.tar.gz

SysVinit utilities
==================

ftp://sunsite.unc.edu/pub/Linux/system/Daemons/init/sysvinit-2.64.tar.gz

Util-linux
==========

ftp://sunsite.unc.edu/pub/Linux/system/Misc/util-linux-2.5.tar.gz

Mtools
======

ftp://sunsite.unc.edu/pub/Linux/utils/disk-management/mtools-3.0.src.tar.gz

Fdutils
=======

ftp://sunsite.unc.edu/pub/Linux/system/Misc/fdutils-4.3.src.tar.gz

Other Info
==========

   Please remember that most of these utils are available on your
favorite local linux mirror.  If you can, please get them from a closer
site before checking sunsite.

   Also, for those of you running Red Hat (or RPM on a different
distribution), most of these are available in RPM format.  Check around
your favorite Red Hat mirror site before installing the non-RPM
version.  Remember, you might need to use the -force option to get the
upgrade to install.  Almost everything you need is available in
ftp://ftp.redhat.com/pub/current/i386/updates/2.0-kernel/ and its
mirrors.

   For others, David Bourgin has put together a package of everything
necessary to quickly and easily upgrade to 2.0.x.  See
ftp://ftp.wsc.com/pub/freeware/linux/update.linux/ for more information
and the files.  This package also includes many bug-fixes, such as the
latest sendmail. There's also an alternate lightweight termcap in the
same directory that works well for many people.

Please send info about any other packages that 2.0.x "broke" or about
any new features of 2.0.x that require extra or new packages for use to
Chris Ricker <kaboom@gatech.edu>.  I generate this from a modified
texinfo setup, so you don't need to bother generating a diff against
the current version before you send the additional information to me.

